/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 505
#ifdef HAVE_CONFIG_H
#line 505
# include <config.h>
#line 505
#endif
#line 505
#include <sys/types.h>
#line 505

#line 505
#include "mailfromd.h"
#line 505
#include "prog.h"
#line 505
#include "builtin.h"
#line 505

#line 484 "sa.bi"
static size_t debug_handle;
#line 505 "sa.bi"

#line 660 "../../src/builtin/snarf.m4"

#line 1 "sa.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <signal.h>

static size_t sa_score_loc
#line 25 "sa.bi"
;
static size_t sa_threshold_loc
#line 26 "sa.bi"
;
static size_t sa_keywords_loc
#line 27 "sa.bi"
;
static size_t clamav_virus_name_loc
#line 28 "sa.bi"
;

static int
set_xscript(mu_stream_t *pstr)
{
	int rc;
	mu_stream_t tstr = *pstr;
	
	if (mu_debug_level_p(debug_handle, MU_DEBUG_PROT)) {
		int rc;
		mu_stream_t dstr, xstr;

		rc = mu_dbgstream_create(&dstr, MU_DIAG_DEBUG);
		if (rc)
			mu_error(_("cannot create debug stream; "
				   "transcript disabled: %s"),
				 mu_strerror (rc));
		else {
			rc = mu_xscript_stream_create(&xstr, tstr, dstr, NULL);
			if (rc)
				mu_error (_("cannot create transcript "
					    "stream: %s"),
					  mu_strerror (rc));
			else {
				mu_stream_unref(tstr);
				tstr = xstr;
				if (mu_debug_level_p(debug_handle,
						     MU_DEBUG_TRACE9)) {
					int xlev = MU_XSCRIPT_PAYLOAD;
					mu_stream_ioctl (tstr,
						 MU_IOCTL_XSCRIPTSTREAM,
						 MU_IOCTL_XSCRIPTSTREAM_LEVEL,
						 &xlev);
				}
				*pstr = tstr;
			}
		}
	}
	return rc;
}

static int
spamd_connect(eval_environ_t env, mu_stream_t *pstream,
	      const char *host, int port)
{
	int rc;
	char *fname;
	mu_stream_t tstr, istr, ostr;
	
	if (port) {
		fname = "mu_tcp_stream_create";
		rc = mu_tcp_stream_create(&tstr, host, port, MU_STREAM_RDWR);
	} else {
		fname = "mu_socket_stream_create";
		rc = mu_socket_stream_create(&tstr, host, MU_STREAM_RDWR);
	}
	mu_stream_set_buffer (tstr, mu_buffer_line, 0);
	
		if (!(rc == 0))
#line 86
			env_throw_bi(env, mfe_failure, NULL, "%s: %s",fname,mu_strerror(rc))
#line 88
;

	rc = mu_filter_create(&istr, tstr, "CRLF",
			      MU_FILTER_DECODE, MU_FILTER_READ);
	mu_stream_unref(tstr);
		if (!(rc == 0))
#line 93
			env_throw_bi(env, mfe_failure, NULL, "%s input filter: %s",fname,mu_strerror(rc))
#line 95
;
	mu_stream_set_buffer (istr, mu_buffer_line, 0);
	
	rc = mu_filter_create(&ostr, tstr, "CRLF",
			      MU_FILTER_ENCODE, MU_FILTER_WRITE);
	mu_stream_unref(tstr);
		if (!(rc == 0))
#line 101
			env_throw_bi(env, mfe_failure, NULL, "%s output filter: %s",fname,mu_strerror(rc))
#line 103
;
	mu_stream_set_buffer (ostr, mu_buffer_line, 0);
	
	rc = mu_iostream_create(&tstr, istr, ostr);
	mu_stream_unref(istr);
	mu_stream_unref(ostr);
		if (!(rc == 0))
#line 109
			env_throw_bi(env, mfe_failure, NULL, "I/O stream: %s",mu_strerror(rc))
#line 111
;
	mu_stream_set_buffer (tstr, mu_buffer_line, 0);
	set_xscript(&tstr);
	*pstream = tstr;
	return rc;
}

static int
spamd_get_line(mu_stream_t stream, char **pbuffer, size_t *psize)
{
	int rc = mu_stream_getline(stream, pbuffer, psize, NULL);
	if (rc == 0)
		mu_rtrim_class (*pbuffer, MU_CTYPE_SPACE);
	return rc;
}

#define char_to_num(c) (c-'0')

static void
decode_float(long *vn, char *str, int digits)
{
	long v;
	size_t frac = 0;
	size_t base = 1;
	int i;
	int negative = 0;
  
	for (i = 0; i < digits; i++)
		base *= 10;
  
	v = strtol(str, &str, 10);
	if (v < 0) {
		negative = 1;
		v = - v;
	}
  
	v *= base;
	if (*str == '.') {
		for (str++, i = 0; *str && i < digits; i++, str++)
			frac = frac * 10 + char_to_num (*str);
		if (*str) {
			if (char_to_num(*str) >= 5)
				frac++;
		}
		else
			for (; i < digits; i++)
				frac *= 10;
	}
	*vn = v + frac;
	if (negative)
		*vn = - *vn;
}

static int
decode_boolean (char *str)
{
	if (strcasecmp (str, "true") == 0)
		return 1;
	else if (strcasecmp (str, "false") == 0)
		return 0;
	/*else?*/
	return 0;
}

typedef RETSIGTYPE (*signal_handler_fn)(int);

static signal_handler_fn
set_signal_handler (int sig, signal_handler_fn h)
{
#ifdef HAVE_SIGACTION
	struct sigaction act, oldact;
	act.sa_handler = h;
	sigemptyset (&act.sa_mask);
	act.sa_flags = 0;
	sigaction (sig, &act, &oldact);
	return oldact.sa_handler;
#else
	return signal (sig, h);
#endif
}

static int got_sigpipe;

static RETSIGTYPE
sigpipe_handler (int sig)
{
	got_sigpipe = 1;
}

mu_stream_t
open_connection(eval_environ_t env, char *urlstr, char **phost)
{
	const char *path = NULL;
	short port = 0;
	mu_stream_t str = NULL;
	int rc;
	
	if (urlstr[0] == '/') {
		path = strdup(urlstr);
		if (!path)
			runtime_error(env, _("not enough memory"));
	} else {
		const char *buf;
		mu_url_t url = NULL;
		
		rc = mu_url_create(&url, urlstr);
		if (rc)
				env_throw_bi(env, mfe_failure, NULL, _("cannot create URL from `%s': %s"),urlstr,mu_strerror(rc));
#line 221
		
		if (rc = mu_url_sget_scheme(url, &buf)) {
			mu_url_destroy(&url);
				env_throw_bi(env, mfe_url, NULL, _("%s: cannot get scheme: %s"),urlstr,mu_strerror(rc));
#line 227
		}

		if (strcmp(buf, "file") == 0
		    || strcmp(buf, "socket") == 0) {
			if (rc = mu_url_sget_path(url, &path)) {
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get path: %s"),urlstr,mu_strerror(rc));
#line 235
			}
		} else if (strcmp(buf, "tcp") == 0) {
			unsigned n;
			
			if (rc = mu_url_get_port(url, &n)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get port: %s"),urlstr,mu_strerror(rc));
#line 244
			}

			if (n == 0 || (port = n) != n) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_range, NULL, _("port out of range: %u"),n);
#line 251
			}
			
			if (rc = mu_url_sget_host(url, &path)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get host: %s"),urlstr,mu_strerror(rc));
#line 258
			}
		} else
				env_throw_bi(env, mfe_url, NULL, _("invalid URL: %s"),buf);
#line 262

		mu_url_destroy(&url);
	}

	rc = spamd_connect(env, &str, path, port);
	
	if (rc == 0 && phost) {
		if (port)
			*phost = strdup(path);
		else
			*phost = NULL;
	}
	return str;
}	


	
void
#line 279
bi_sa(eval_environ_t env)
#line 279

#line 279 "sa.bi"
{
#line 279
	
#line 279

#line 279
long __bi_argcnt;
#line 279
char * urlstr;
#line 279
        long  prec;
#line 279
        long  report;
#line 279
        
#line 279
get_string_arg(env, 1, &urlstr);
#line 279
        get_numeric_arg(env, 2, &prec);
#line 279
        get_numeric_arg(env, 3, &report);
#line 279
        
#line 279
get_numeric_arg(env, 0, &__bi_argcnt);
#line 279
        adjust_stack(env, __bi_argcnt + 1);
#line 279

#line 279
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 279
		prog_trace(env, "sa %s %lu %lu",urlstr, prec, ((__bi_argcnt > 2) ? report : 0));;
#line 279

{
	mu_off_t msize;
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t ostr;
	signal_handler_fn handler;
	char *buffer = NULL;
	size_t bufsize = 0;
	size_t n;
	char version_str[19];
	char spam_str[6], score_str[21], threshold_str[21];
	long version;
	int result;
	long score, threshold;
	int report_mode = ((__bi_argcnt > 2) ? report : 0);
	int rc;
	
	rc = mu_stream_size(mstr, &msize);
		if (!(rc == 0))
#line 297
			env_throw_bi(env, mfe_failure, "sa", "mu_stream_size: %s",mu_strerror (rc))
#line 300
;

	ostr = open_connection(env, urlstr, NULL);
		
	msize += env_get_line_count(env);
	mu_stream_printf(ostr,
			   report_mode ? "REPORT SPAMC/1.2\n"
			               : "SYMBOLS SPAMC/1.2\n");
	mu_stream_printf(ostr, "Content-length: %lu\n",
			 (unsigned long) msize);
	/*FIXME: spamd_send_command(ostr, "User: %s", ??) */
	got_sigpipe = 0;
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	mu_stream_write(ostr, "\n", 1, NULL);
	if (rc = mu_stream_copy(ostr, mstr, 0, NULL)) {
		mu_stream_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("send stream failed: %s"),mu_strerror (rc));
#line 319
	}
	mu_stream_shutdown(ostr, MU_STREAM_WRITE);
	set_signal_handler(SIGPIPE, handler);
	
	spamd_get_line(ostr, &buffer, &bufsize);
	if (got_sigpipe) {
		mu_stream_destroy(&ostr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "sa", _("remote side has closed connection"));
	}

	if (sscanf(buffer, "SPAMD/%18s %d %*s", version_str, &result) != 2) {
		mu_stream_destroy(&ostr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad string '%s'"),buffer);
#line 336
	}

	decode_float(&version, version_str, 1);
	if (version < 10) {
		mu_stream_destroy(&ostr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "sa", _("unsupported SPAMD version: %s"),version_str);
#line 345
	}

	if (result) {
		mu_stream_destroy(&ostr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "sa", "%s",buffer);
	}
	
	spamd_get_line(ostr, &buffer, &bufsize);
	if (sscanf (buffer, "Spam: %5s ; %20s / %20s",
		    spam_str, score_str, threshold_str) != 3) {
		mu_stream_destroy(&ostr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad Spam header '%s'"),buffer);
#line 361
	}

	result = decode_boolean(spam_str);
	decode_float(&score, score_str, prec);
	decode_float(&threshold, threshold_str, prec);

	*env_data_ref(env, sa_score_loc) = (STKVAL) (score);
	*env_data_ref(env, sa_threshold_loc) = (STKVAL) (threshold);

	/* Skip newline */
	spamd_get_line(ostr, &buffer, &bufsize);
	if (report_mode) {
		heap_obstack_begin(env);
		while (mu_stream_getline(ostr, &buffer, &bufsize, &n) == 0
		       && n > 0) 
			heap_obstack_grow(env, buffer, n);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		*env_data_ref(env, sa_keywords_loc) = (STKVAL) (heap_obstack_finish(env));
	} else {
		/* Read symbol list */
		spamd_get_line(ostr, &buffer, &bufsize);

		
#line 383
{ size_t __off;
#line 383
  const char *__s = buffer;
#line 383
  if (__s)
#line 383
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 383
  else
#line 383
     __off = 0;
#line 383
  *env_data_ref(env, sa_keywords_loc) = (STKVAL) (__off); }
#line 383
;
	
		while (mu_stream_getline(ostr, &buffer, &bufsize, &n) == 0
		       && n > 0) 
			/* Drain input */;
	}
  	mu_stream_destroy(&ostr);
	free(buffer);
	
#line 391
do {
#line 391
  push(env, (STKVAL) (result));
#line 391
  return;
#line 391
} while (0);
}
}

static int
clamav_open_data_stream(mu_stream_t *retstr, const char *host, unsigned port)
{
	mu_stream_t tstr, dstr;
	int rc = mu_tcp_stream_create(&dstr, host, port, 0);
	if (rc)
		return rc;
	rc = mu_filter_create(&tstr, dstr, "CRLF",
			      MU_FILTER_ENCODE, MU_FILTER_WRITE);
	mu_stream_unref(dstr);
	if (rc)
		return rc;
	set_xscript(&tstr);
	*retstr = tstr;
	return 0;
}
	

	
void
#line 414
bi_clamav(eval_environ_t env)
#line 414

#line 414 "sa.bi"
{
#line 414
	
#line 414

#line 414

#line 414
char * urlstr;
#line 414
        
#line 414
get_string_arg(env, 0, &urlstr);
#line 414
        
#line 414

#line 414
        adjust_stack(env, 1);
#line 414

#line 414
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 414
		prog_trace(env, "clamav %s",urlstr);;
#line 414

{
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t cstr, dstr;
	char *buffer = NULL;
	size_t bufsize = 0;
	char *host;
	unsigned short port;
	int rc;
	signal_handler_fn handler;
	char *p;
	
	cstr = open_connection(env, urlstr, &host);

	mu_stream_printf(cstr, "STREAM\n");
	spamd_get_line(cstr, &buffer, &bufsize);
	if (sscanf(buffer, "PORT %hu", &port) != 1) {
		mu_stream_destroy(&cstr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "clamav", _("bad response from clamav: expected `PORT' but found `%s'"),buffer);
#line 436
	}

	if (!host) 
		host = strdup("127.0.0.1"); /* FIXME */
	rc = clamav_open_data_stream(&dstr, host, port);
	free(host);
	if (rc) {
		mu_stream_destroy(&cstr);
			env_throw_bi(env, mfe_failure, "clamav", "mu_tcp_stream_create: %s",mu_strerror(rc));
#line 447
	}
	
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	rc = mu_stream_copy(dstr, mstr, 0, NULL);
	mu_stream_shutdown(dstr, MU_STREAM_WRITE);
	mu_stream_destroy(&dstr);
	set_signal_handler(SIGPIPE, handler);
	if (rc) {
		mu_stream_destroy(&cstr);
		free(buffer);
			env_throw_bi(env, mfe_failure, "clamav", _("sending to stream failed: %s"),mu_strerror (rc));
#line 460
	}

	rc = spamd_get_line(cstr, &buffer, &bufsize);
	mu_stream_destroy(&cstr);
		if (!(rc == 0))
#line 464
			env_throw_bi(env, mfe_failure, "clamav", _("error reading clamav response: %s"),mu_strerror(rc))
;

	p = strrchr(buffer, ' ');
        	if (!(p))
#line 468
			env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer)
;
	++p;
	if (strncmp(p, "OK", 2) == 0)
		rc = 0;
	else if (strncmp(p, "FOUND", 5) == 0) {
		char *s;
			
		*--p = '\0';
		s = strrchr(buffer, ' ');
		if (!s)
			s = buffer;
		else
			s++;
		
#line 482
{ size_t __off;
#line 482
  const char *__s = s;
#line 482
  if (__s)
#line 482
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 482
  else
#line 482
     __off = 0;
#line 482
  *env_data_ref(env, clamav_virus_name_loc) = (STKVAL) (__off); }
#line 482
;

		
#line 484 "sa.bi"

#line 484
mu_debug(debug_handle, 2,("%sclamav found %s",
		          mailfromd_msgid(env_get_context(env)), s));
#line 487
		rc = 1;
	} else if (strncmp(p, "ERROR", 5) == 0) {
		/* FIXME: mf code */
		free(buffer);
			env_throw_bi(env, mfe_failure, "clamav", _("clamav error: %s"),buffer);
#line 494
	} else {
		free(buffer);
			env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer);
#line 499
	}
	free(buffer);
	
#line 501
do {
#line 501
  push(env, (STKVAL) (rc));
#line 501
  return;
#line 501
} while (0);
}
}


#line 505
void
#line 505
sa_init_builtin()
#line 505
{
#line 505
		debug_handle = mu_debug_register_category("bi_sa");
#line 505

#line 505
	#line 25 "sa.bi"
	builtin_variable_install("sa_score", dtype_number, SYM_VOLATILE, &sa_score_loc);
#line 26 "sa.bi"
	builtin_variable_install("sa_threshold", dtype_number, SYM_VOLATILE, &sa_threshold_loc);
#line 27 "sa.bi"
	builtin_variable_install("sa_keywords", dtype_string, SYM_VOLATILE, &sa_keywords_loc);
#line 28 "sa.bi"
	builtin_variable_install("clamav_virus_name", dtype_string, SYM_VOLATILE, &clamav_virus_name_loc);
#line 279 "sa.bi"
va_builtin_install_ex("sa", bi_sa, STATMASK(smtp_state_eom), dtype_number, 3, 1, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number, dtype_number);
#line 414 "sa.bi"
va_builtin_install_ex("clamav", bi_clamav, STATMASK(smtp_state_eom), dtype_number, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_string);

#line 505 "sa.bi"
	
#line 505
}
#line 505 "sa.bi"

#line 505


#line 654 "../../src/builtin/snarf.m4"

#line 654

